#pragma once

#pragma pack(push,1)			// Data seems to be aligned to 4 bytes but use this just in case it messes up the freads.

struct TEXCONTAINERHEADER {
	int Magic;  // Always GEKV
    int Version;    // Always 13
    int SizeOf_cpeg_pc;
    int SizeOf_gpeg_pc;
    int NumberOfTextures;
    short NumberOfTexturesDup;
    short Unknown3[5]; // the number of bytes here
                        // is different than before
};

enum TEXTURETYPES {
	D3DFMT_DXT1=400,
    D3DFMT_DXT3,
    D3DFMT_DXT5,
    D3DFMT_R5G6B5,
    D3DFMT_A1R5G5B5,
    D3DFMT_A4R4G4B4,
    D3DFMT_R8G8B8,
    D3DFMT_A8R8G8B8,
    D3DFMT_V8U8,
    D3DFMT_CxV8U8,
    D3DFMT_A8,
    UK,
    UK2,
    DXGI_BC5, // This one I have as BC5 because it looks better 
    // Than BC1-4, but not sure this compression algorithm is 100% correct
    // Also don't think it's B6H or B7 but not sure
    DXGI_BC4, //This one I'm pretty sure is BC4
    DXGI_BC52, // Also unsure with this one but very viewable with BC5
    D3DFMT_DXT5alt=701,
	FORCE32BITS=0x7fffffff
};

struct TEXCONTAINERRECORD {
	long long int FileOffsetOfData;		
    unsigned short Width;
    unsigned short Height;
    TEXTURETYPES TextureEnum;
    unsigned char Unk_Flags[6];
    unsigned char HasAlpha;
    unsigned short Unknown3[8]; // No idea what this is
    // there are 8 more bytes in here
	unsigned char Unk_Flag;
    unsigned char Unk_Flags2[11];
    unsigned char NumberOfMipLevels;
    unsigned int SizeOfData;
    unsigned short Unknown4[16]; // Always filled with zeros?
};
#pragma pack(pop)

/*
 struct peg_entry {
uint64 *data;
uint16 width;
uint16 height;
uint16 bitmap_format;
uint16 pal_format;
uint32 mip_filter;
uint16 number_of_frames;
uint16 flags;
float average_red;
float average_green;
float average_blue;
float average_alpha;
uint64 *filename;
uint16 pal_size;
uint8 fps;
uint8 mip_levels; // (base frame + number of mips, always at least 1)
uint32 frame_size; // (bytes in palette + image)
peg_entry *next; // (runtime)
peg_entry *prev; // (runtime)
uint8 *cache[2]; // (runtime)
}
*/

struct DDS_PIXELFORMAT {
  DWORD dwSize;
  DWORD dwFlags;
  DWORD dwFourCC;
  DWORD dwRGBBitCount;
  DWORD dwRBitMask;
  DWORD dwGBitMask;
  DWORD dwBBitMask;
  DWORD dwABitMask;
};

struct DDS_HEADER {
	DWORD			Magic;
	DWORD           dwSize;
	DWORD           dwFlags;
	DWORD           dwHeight;
	DWORD           dwWidth;
	DWORD           dwPitchOrLinearSize;
	DWORD           dwDepth;
	DWORD           dwMipMapCount;
	DWORD           dwReserved1[11];
	DDS_PIXELFORMAT ddspf;
	DWORD           dwCaps;
	DWORD           dwCaps2;
	DWORD           dwCaps3;
	DWORD           dwCaps4;
	DWORD           dwReserved2;
};